.ORG 0x00          
    JMP main            
; ====================================================       
;    1,1,2,3,5,8,13,21,34,55,89,144,233 ...(< 255)

; For this reason we must save the numbers in 2 Byte.
; ====================================================       
   
main:
    ; second : 1 
    LDI R16, 1      ; low bits  0001           
    LDI R17, 0      ; high bits 0000
    
    ; first : 1 
    LDI R18, 0      ; low bits  0000      
    LDI R19, 0      ; high bits 0000

    ; Address Pointer
    LDI R26, 0x00       
    LDI R27, 0x02     

    ; counter   
    LDI R20, 25

; ====================================================       

loop:
    ; Store F(n) 
    ST X+, R16      ; low bits         
    ST X+, R17      ; high bits   

    ; Copy F(n) 
    MOV R22, R16 
    MOV R23, R17 
    
    ; calculate F(n+1) -> Add F(n) with F(n-1)
    ADD R16, R18  
    ADC R17, R19  

    ; Move F(n) to F(n-1)
    MOV R18, R22    
    MOV R19, R23     

    ; check loop counter 
    DEC R20
    BRNE loop         

; ====================================================       

finish:
    JMP finish           



